## com.sun.jersey.api.model
Class AbstractResource

    java.lang.Object
      com.sun.jersey.api.model.AbstractResource

All Implemented Interfaces:
  AbstractModelComponent, PathAnnotated, java.lang.reflect.AnnotatedElement

    public class AbstractResource

extends java.lang.Object
implements PathAnnotated, AbstractModelComponent, java.lang.reflect.AnnotatedElement

Abstraction for resource class

Constructor Summary
`AbstractResource(java.lang.Class<?> resourceClass)` Creates a new instance of AbstractResource
`AbstractResource(java.lang.Class<?> resourceClass, PathValue uriPath)` Creates a new instance of AbstractResource
`AbstractResource(java.lang.String path, AbstractResource ar)` Create a new instance from an existing AbstractResource but defining a new path.

Method Summary
`void` | `accept(AbstractModelVisitor visitor)`

`

`<T extends java.lang.annotation.Annotation> T`

`

`getAnnotation(java.lang.Class<T> a)`

`java.lang.annotation.Annotation[]` | `getAnnotations()`
`java.util.List<AbstractModelComponent>` | `getComponents()`
`java.util.List<AbstractResourceConstructor>` | `getConstructors()`
`java.lang.annotation.Annotation[]` | `getDeclaredAnnotations()`
`java.util.List<AbstractField>` | `getFields()`
`PathValue` | `getPath()`
`java.util.List<java.lang.reflect.Method>` | `getPostConstructMethods()`
`java.util.List<java.lang.reflect.Method>` | `getPreDestroyMethods()`
`java.lang.Class<?>` | `getResourceClass()`
`java.util.List<AbstractResourceMethod>` | `getResourceMethods()` Provides a non-null list of resource methods available on the resource
`java.util.List<AbstractSetterMethod>` | `getSetterMethods()`
`java.util.List<AbstractSubResourceLocator>` | `getSubResourceLocators()` Provides a non-null list of subresource locators available on the resource
`java.util.List<AbstractSubResourceMethod>` | `getSubResourceMethods()` Provides a non-null list of subresource methods available on the resource
`boolean` | `isAnnotationPresent(java.lang.Class<? extends java.lang.annotation.Annotation> a)`
`boolean` | `isRootResource()`
`boolean` | `isSubResource()`
`java.lang.String` | `toString()`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AbstractResource

    public AbstractResource(java.lang.Class<?> resourceClass)

  Creates a new instance of AbstractResource

### AbstractResource

    public AbstractResource(java.lang.Class<?> resourceClass,
                            PathValue uriPath)

  Creates a new instance of AbstractResource

### AbstractResource

    public AbstractResource(java.lang.String path,
                            AbstractResource ar)

  Create a new instance from an existing AbstractResource but defining a new path.

  Parameters:
    `path` - the path.
    `ar` - the existing abstract resource.

Method Detail

### getResourceClass

    public java.lang.Class<?> getResourceClass()

### isSubResource

    public boolean isSubResource()

### isRootResource

    public boolean isRootResource()

### getPath

    public PathValue getPath()

  Specified by:
    `getPath` in interface `PathAnnotated`

### getConstructors

    public java.util.List<AbstractResourceConstructor> getConstructors()

### getFields

    public java.util.List<AbstractField> getFields()

### getSetterMethods

    public java.util.List<AbstractSetterMethod> getSetterMethods()

### getResourceMethods

    public java.util.List<AbstractResourceMethod> getResourceMethods()

  Provides a non-null list of resource methods available on the resource

  Returns:
    non-null abstract resource method list

### getSubResourceMethods

    public java.util.List<AbstractSubResourceMethod> getSubResourceMethods()

  Provides a non-null list of subresource methods available on the resource

  Returns:
    non-null abstract subresource method list

### getSubResourceLocators

    public java.util.List<AbstractSubResourceLocator> getSubResourceLocators()

  Provides a non-null list of subresource locators available on the resource

  Returns:
    non-null abstract subresource locator list

### getPostConstructMethods

    public java.util.List<java.lang.reflect.Method> getPostConstructMethods()

  Returns:
    the postCreate

### getPreDestroyMethods

    public java.util.List<java.lang.reflect.Method> getPreDestroyMethods()

  Returns:
    the preDestroy

### accept

    public void accept(AbstractModelVisitor visitor)

  Specified by:
    `accept` in interface `AbstractModelComponent`

### isAnnotationPresent

    public boolean isAnnotationPresent(java.lang.Class<? extends java.lang.annotation.Annotation> a)

  Specified by:
    `isAnnotationPresent` in interface `java.lang.reflect.AnnotatedElement`

### getAnnotation

    public <T extends java.lang.annotation.Annotation> T getAnnotation(java.lang.Class<T> a)

  Specified by:
    `getAnnotation` in interface `java.lang.reflect.AnnotatedElement`

### getAnnotations

    public java.lang.annotation.Annotation[] getAnnotations()

  Specified by:
    `getAnnotations` in interface `java.lang.reflect.AnnotatedElement`

### getDeclaredAnnotations

    public java.lang.annotation.Annotation[] getDeclaredAnnotations()

  Specified by:
    `getDeclaredAnnotations` in interface `java.lang.reflect.AnnotatedElement`

### toString

    public java.lang.String toString()

  Overrides:
    `toString` in class `java.lang.Object`

### getComponents

    public java.util.List<AbstractModelComponent> getComponents()

  Specified by:
    `getComponents` in interface `AbstractModelComponent`

Copyright © 2017 Oracle Corporation. All Rights Reserved.